import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.UI.Extensions";

local function out(msg)
	Turbine.Shell.WriteLine(msg);
end

EmoEmotes = class();

_emotes = {};

function EmoEmotes:Constructor()
	self.loading = false;
	self:Reload();
end

function EmoEmotes:Save()
	self:p_SaveCustomEmotes();
end

function EmoEmotes:Reload()
	for k in pairs(_emotes) do
		_emotes[k] = nil;
	end
	_emotes = nil;
	_emotes = {};
	self:p_SetGameEmotes();
	self:p_ReadCustomEmotes();
end

function EmoEmotes:SetCustomEmote(pname, pemote, pnotarget_all)
	if (_emotes[pname] ~= nil) then
		_emotes[pname] = nil;
	end
	
	_emotes[pname] = self:p_NewGameEmote(pname);
	_emotes[pname].emote = pemote;
	_emotes[pname].custom = true;
	_emotes[pname].no_target = pnotarget_all;
end

function EmoEmotes:p_SetGameEmotes()
	_emotes["/ahem"] = self:p_NewGameEmote("/ahem");
	_emotes["/angry"] = self:p_NewGameEmote("/angry");
	_emotes["/assist"] = self:p_NewGameEmote("/assist");
	_emotes["/attack"] = self:p_NewGameEmote("/attack");
	_emotes["/away"] = self:p_NewGameEmote("/away");
	_emotes["/beckon"] = self:p_NewGameEmote("/beckon");
	_emotes["/beg"] = self:p_NewGameEmote("/beg");
	_emotes["/bio"] = self:p_NewGameEmote("/bio");
	_emotes["/blush"] = self:p_NewGameEmote("/blush");
	_emotes["/bored"] = self:p_NewGameEmote("/bored");
	_emotes["/bother"] = self:p_NewGameEmote("/bother");
	_emotes["/bow"] = self:p_NewGameEmote("/bow");
	_emotes["/brb"] = self:p_NewGameEmote("/brb");
	_emotes["/burp"] = self:p_NewGameEmote("/burp");
	_emotes["/bye"] = self:p_NewGameEmote("/bye");
	_emotes["/calm"] = self:p_NewGameEmote("/calm");
	_emotes["/challenge"] = self:p_NewGameEmote("/challenge");
	_emotes["/charge"] = self:p_NewGameEmote("/charge");
	_emotes["/cheer"] = self:p_NewGameEmote("/cheer");
	_emotes["/chip"] = self:p_NewGameEmote("/chip");
	_emotes["/chuckle"] = self:p_NewGameEmote("/chuckle");
	_emotes["/agree"] = self:p_NewGameEmote("/agree");
	_emotes["/clap"] = self:p_NewGameEmote("/clap");
	_emotes["/confused"] = self:p_NewGameEmote("/confused");
	_emotes["/congratulate"] = self:p_NewGameEmote("/congratulate");
	_emotes["/cough"] = self:p_NewGameEmote("/cough");
	_emotes["/cower"] = self:p_NewGameEmote("/cower");
	_emotes["/crazy"] = self:p_NewGameEmote("/crazy");
	_emotes["/cry"] = self:p_NewGameEmote("/cry");
	_emotes["/curtsey"] = self:p_NewGameEmote("/curtsey");
	_emotes["/dance"] = self:p_NewGameEmote("/dance");
	_emotes["/dance1"] = self:p_NewGameEmote("/dance1");
	_emotes["/dance2"] = self:p_NewGameEmote("/dance2");
	_emotes["/dance3"] = self:p_NewGameEmote("/dance3");
	_emotes["/dance_dwarf"] = self:p_NewGameEmote("/dance_dwarf");
	_emotes["/dance_dwarf2"] = self:p_NewGameEmote("/dance_dwarf2");
	_emotes["/dance_elf"] = self:p_NewGameEmote("/dance_elf");
	_emotes["/dance_elf2"] = self:p_NewGameEmote("/dance_elf2");
	_emotes["/dance_hobbit"] = self:p_NewGameEmote("/dance_hobbit");
	_emotes["/dance_hobbit2"] = self:p_NewGameEmote("/dance_hobbit2");
	_emotes["/dance_jig"] = self:p_NewGameEmote("/dance_jig");
	_emotes["/dance_man"] = self:p_NewGameEmote("/dance_man");
	_emotes["/dance_man2"] = self:p_NewGameEmote("/dance_man2");
	_emotes["/drink"] = self:p_NewGameEmote("/drink");
	_emotes["/drive"] = self:p_NewGameEmote("/drive");
	_emotes["/drool"] = self:p_NewGameEmote("/drool");
	_emotes["/drunk"] = self:p_NewGameEmote("/drunk");
	_emotes["/dustoff"] = self:p_NewGameEmote("/dustoff");
	_emotes["/eat"] = self:p_NewGameEmote("/eat");
	_emotes["/faint"] = self:p_NewGameEmote("/faint");
	_emotes["/feather"] = self:p_NewGameEmote("/feather");
	_emotes["/fidget"] = self:p_NewGameEmote("/fidget");
	_emotes["/fight"] = self:p_NewGameEmote("/fight");
	_emotes["/firebreath"] = self:p_NewGameEmote("/firebreath");
	_emotes["/fishslap"] = self:p_NewGameEmote("/fishslap");
	_emotes["/flex"] = self:p_NewGameEmote("/flex");
	_emotes["/flip"] = self:p_NewGameEmote("/flip");
	_emotes["/flirt"] = self:p_NewGameEmote("/flirt");
	_emotes["/followme"] = self:p_NewGameEmote("/followme");
	_emotes["/giggle"] = self:p_NewGameEmote("/giggle");
	_emotes["/grumble"] = self:p_NewGameEmote("/grumble");
	_emotes["/hail"] = self:p_NewGameEmote("/hail");
	_emotes["/handstand"] = self:p_NewGameEmote("/handstand");
	_emotes["/heropose"] = self:p_NewGameEmote("/heropose");
	_emotes["/hug"] = self:p_NewGameEmote("/hug");
	_emotes["/impatient"] = self:p_NewGameEmote("/impatient");
	_emotes["/innocent"] = self:p_NewGameEmote("/innocent");
	_emotes["/juggle"] = self:p_NewGameEmote("/juggle");
	_emotes["/jump"] = self:p_NewGameEmote("/jump");
	_emotes["/kiss"] = self:p_NewGameEmote("/kiss");
	_emotes["/kneel"] = self:p_NewGameEmote("/kneel");
	_emotes["/laugh"] = self:p_NewGameEmote("/laugh");
	_emotes["/liedown"] = self:p_NewGameEmote("/liedown");
	_emotes["/lol"] = self:p_NewGameEmote("/lol");
	_emotes["/look"] = self:p_NewGameEmote("/look");
	_emotes["/lookaround"] = self:p_NewGameEmote("/lookaround");
	_emotes["/meditate"] = self:p_NewGameEmote("/meditate");
	_emotes["/mock"] = self:p_NewGameEmote("/mock");
	_emotes["/mood_angry"] = self:p_NewGameEmote("/mood_angry");
	_emotes["/mood_apprehensive"] = self:p_NewGameEmote("/mood_apprehensive");
	_emotes["/mood_calm "] = self:p_NewGameEmote("/mood_calm");
	_emotes["/mood_confused"] = self:p_NewGameEmote("/mood_confused");
	_emotes["/mood_fearful"] = self:p_NewGameEmote("/mood_fearful");
	_emotes["/mood_happy"] = self:p_NewGameEmote("/mood_happy");
	_emotes["/mood_mischievous"] = self:p_NewGameEmote("/mood_mischievous");
	_emotes["/mood_sad"] = self:p_NewGameEmote("/mood_sad");
	_emotes["/mood_sleepy"] = self:p_NewGameEmote("/mood_sleepy");
	_emotes["/mood_solemn"] = self:p_NewGameEmote("/mood_solemn");
	_emotes["/mood_surprised"] = self:p_NewGameEmote("/mood_surprised");
	_emotes["/mourn"] = self:p_NewGameEmote("/mourn");
	_emotes["/mumble"] = self:p_NewGameEmote("/mumble");
	_emotes["/munch"] = self:p_NewGameEmote("/munch");
	_emotes["/no"] = self:p_NewGameEmote("/no");
	_emotes["/nothing"] = self:p_NewGameEmote("/nothing");
	_emotes["/oop"] = self:p_NewGameEmote("/oop");
	_emotes["/pat"] = self:p_NewGameEmote("/pat");
	_emotes["/pick"] = self:p_NewGameEmote("/pick");
	_emotes["/point"] = self:p_NewGameEmote("/point");
	_emotes["/poke"] = self:p_NewGameEmote("/poke");
	_emotes["/pose"] = self:p_NewGameEmote("/pose");
	_emotes["/pushups"] = self:p_NewGameEmote("/pushups");
	_emotes["/putt"] = self:p_NewGameEmote("/putt");
	_emotes["/ready"] = self:p_NewGameEmote("/ready");
	_emotes["/rest"] = self:p_NewGameEmote("/rest");
	_emotes["/roar"] = self:p_NewGameEmote("/roar");
	_emotes["/rude"] = self:p_NewGameEmote("/rude");
	_emotes["/sad"] = self:p_NewGameEmote("/sad");
	_emotes["/salute"] = self:p_NewGameEmote("/salute");
	_emotes["/scold"] = self:p_NewGameEmote("/scold");
	_emotes["/scratch"] = self:p_NewGameEmote("/scratch");
	_emotes["/shakefist"] = self:p_NewGameEmote("/shakefist");
	_emotes["/shiver"] = self:p_NewGameEmote("/shiver");
	_emotes["/shrug"] = self:p_NewGameEmote("/shrug");
	_emotes["/sigh"] = self:p_NewGameEmote("/sigh");
	_emotes["/sing"] = self:p_NewGameEmote("/sing");
	_emotes["/sit"] = self:p_NewGameEmote("/sit");
	_emotes["/slap"] = self:p_NewGameEmote("/slap");
	_emotes["/smackhead"] = self:p_NewGameEmote("/smackhead");
	_emotes["/smoke"] = self:p_NewGameEmote("/smoke");
	_emotes["/smoke1"] = self:p_NewGameEmote("/smoke1");
	_emotes["/sneeze"] = self:p_NewGameEmote("/sneeze");
	_emotes["/sorry"] = self:p_NewGameEmote("/sorry");
	_emotes["/spin"] = self:p_NewGameEmote("/spin");
	_emotes["/stare"] = self:p_NewGameEmote("/stare");
	_emotes["/story"] = self:p_NewGameEmote("/story");
	_emotes["/stretch"] = self:p_NewGameEmote("/stretch");
	_emotes["/surrender"] = self:p_NewGameEmote("/surrender");
	_emotes["/sweat"] = self:p_NewGameEmote("/sweat");
	_emotes["/swordsalute"] = self:p_NewGameEmote("/swordsalute");
	_emotes["/talk "] = self:p_NewGameEmote("/talk");
	_emotes["/tantrum"] = self:p_NewGameEmote("/tantrum");
	_emotes["/tear"] = self:p_NewGameEmote("/tear");
	_emotes["/thank"] = self:p_NewGameEmote("/thank");
	_emotes["/think"] = self:p_NewGameEmote("/think");
	_emotes["/tickle"] = self:p_NewGameEmote("/tickle");
	_emotes["/wait"] = self:p_NewGameEmote("/wait");
	_emotes["/wave"] = self:p_NewGameEmote("/wave");
	_emotes["/whippitydo"] = self:p_NewGameEmote("/whippitydo");
	_emotes["/whistle"] = self:p_NewGameEmote("/whistle");
	_emotes["/wince"] = self:p_NewGameEmote("/wince");
	_emotes["/wink"] = self:p_NewGameEmote("/wink");
	_emotes["/yawn"] = self:p_NewGameEmote("/yawn");
	_emotes["/yes"] = self:p_NewGameEmote("/yes");
end

function EmoEmotes:p_NewGameEmote(gameemote)
	return {
		emote = gameemote,
		custom = false,
		no_target = nil,
		target_to_all = nil,
		target_to_target = nil,
		target_to_self = nil,
	};
end

function EmoEmotes:p_ReadCustomEmotes()
	-- grab customs from options
	self.loading = true;

	local customEmotes = Turbine.PluginData.Load(Turbine.DataScope.Account, "EmoCustomEmotes");

	if (type(customEmotes) ~= "table") then
		customEmotes = {};
	end

	--[[
	TODO: 
	
	if there is a conflict with an existing Game Emote, pop a dialog asking
	for a new name. If we have any of these, immediately after all the changes,
	write the customs back out.
	
	this needs to loop through until we have no conflicts. 
	--]]
	for k, v in pairs(customEmotes) do
		if (_emotes[k] ~= nil) then
			out("Error: Custom emote '"..k.."' is an actual game emote. This may be a recent change. Please rename your custom emote.");
		else
			-- Define it this way to avoid later upgrade issues
			if (v ~= nil and v.emote ~= nil) then
				_emotes[k] = self:p_NewGameEmote(k);
				_emotes[k].emote = v.emote;
				_emotes[k].custom = true;
				if (v.no_target ~= nil) then
					_emotes[k].no_target = v.no_target;
				end
				if (v.target_to_all ~= nil) then
					_emotes[k].target_to_all = v.target_to_all;
				end
				if (v.target_to_target ~= nil) then
					_emotes[k].target_to_target = v.target_to_target;
				end
				if (v.target_to_self ~= nil) then
					_emotes[k].target_to_self = v.target_to_self;
				end
			end
		end
		customEmotes[k] = nil;
	end
	customEmotes = nil;

	self.loading = false;
end

function EmoEmotes:p_SaveCustomEmotes()
	if (self.loading == true) then
		return;
	end
	
	local customEmotes = {};

	-- loop through _emotes and save off the ones which are customs
	for k, v in pairs(_emotes) do
		if (v.custom == true) then
			customEmotes[k] = v;
		end
	end

	-- write out customEmotes to the options
	Turbine.PluginData.Save(Turbine.DataScope.Account, "EmoCustomEmotes", customEmotes);
	
	for k, v in pairs(customEmotes) do
		customEmotes[k] = nil;
	end
	customEmotes = nil;
end
